using System;
using System.Threading;

class App 
{
  public static void Main() 
  {
    // Fr Synchronisierung
    AutoResetEvent asyncOpIsDone = new AutoResetEvent(false);

    // Thread aus ThreadPool aktivieren
    ThreadPool.QueueUserWorkItem(new WaitCallback(MyAsyncOperation), asyncOpIsDone);

    Console.WriteLine("Master thread continues here.....");
    // ...

    Console.WriteLine("Master thead wait now on the asynchronous thread......");
    asyncOpIsDone.WaitOne();
    Console.WriteLine("Ready!!!");
  }

  // delegate (hat immer den Parameter Object und gibt nichts zurck)
  static void MyAsyncOperation(Object state) 
  {
    Console.WriteLine("Thread: Now calculating......");
    // ...
    
    double dSum = 0.0;

    for (int i = 0; i < 100000000; i++)
    {
      dSum += Math.Sqrt(i);
    }

    // Calculation is done
    ((AutoResetEvent)state).Set();
  }
}