using System;
using System.Threading;

namespace Thread1
{
  public class MathClass2
  {
    private int iStart, iEnde;
    private double dSum;
    private bool bInUse = false;

    public Thread Calculate(int i1, int i2)
    {
      if(bInUse)
        return null;

      bInUse = true;
      iStart = i1;
      iEnde = i2;

      Thread th = new Thread(new ThreadStart(CalcBackground));
      
      return th;
    }

    private void CalcBackground()
    {
      dSum = 0.0;

      for(int i = iStart; i < iEnde; i++)
      {
        dSum += Math.Sqrt(i);
      }

      bInUse = false;
    }

    public double Result
    {
      get
      {
        return dSum;
      }
    }
  }

  public class class1
  {
    [STAThread]
    static void Main(string[] args)
    {
      MathClass2 mc1 = new MathClass2();
      Thread th1 = mc1.Calculate(0, 50000000);
      th1.Start();

      Thread th2 = mc1.Calculate(50000000, 100000000);
      th2.Start();

      th1.Join();
      th2.Join();
    }
  }
}
